/**
 * Copyright (c) 2009 - Lehigh University. Bethlehem, PA, USA.
 * All rights reserved.
 * This source code is a part of MARCHES Project. 
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice, the following
 * two paragraphs, and the author attribution appear in all copies of this
 * software.
 *
 * IN NO EVENT SHALL LEHIGH UNIVERSITY BE LIABLE TO ANY PARTY FOR DIRECT, 
 * INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF LEHIGH
 * UNIVERSITY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *	
 * LEHIGH UNIVERSITY SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
 * PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, 
 * AND LEHIGH UNIVERSITY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, 
 * SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 **/

// modsDlg.cpp : implementation file
//

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.Net.Sockets;

namespace VideoConferencing
{
    public partial class FormMain : Form
    {
        MassWare.MassWare massAgent = null;
        public delegate void UpdateLabelCallback(string txt);


        public FormMain()
        {
            InitializeComponent();

            massAgent = new MassWare.MassWare(@"vcRules.xml");
            massAgent.Initialize();
            massAgent.AddArchSubscriber(new MassWare.Architecture.MassWareArchChangeEventHandler(MassWareArchChanged));

            object[] paramlist = {panel1.Handle, panel1.Width, panel1.Height };
            massAgent.SetAppParameter("Masslets.ImageProcess.WebCam", "SetLocalWindowInf", paramlist);
            paramlist = new object[3] { pictureBox1, pictureBox1.Width, pictureBox1.Height };
            massAgent.SetAppParameter("Masslets.ImageProcess.Display", "SetDisplayInf", paramlist);
        }

        private void MassWareArchChanged(object sender, MassWare.MassWareArchEventArgs e)
        {
            if (e.mType == MassWare.MassWareArchEventArgs.PROACTIVE_CHANGE)
            {
                label1.Invoke(new UpdateLabelCallback(UpdateLabelText), new object[] { "Proactive Architecture Changed: \r\n" + e.mMessage + " -> Socket" });
            }
            else if (e.mType == MassWare.MassWareArchEventArgs.REACTIVE_CHANGE)
            {
                label1.Invoke(new UpdateLabelCallback(UpdateLabelText), new object[] { "Reactive Architecture Changed: \r\n" + "Socket -> " + e.mMessage });
            }
        }

        public void UpdateLabelText(string txt)
        {
            label1.Text = txt;
        }

        private void menuItem3_Click(object sender, EventArgs e)
        {
            string strIP;
            FormConnect formConn = new FormConnect();
            if (formConn.ShowDialog() == DialogResult.OK)
            {
                strIP = formConn.mStrIP;
                massAgent.SyncTo(IPAddress.Parse(strIP));
                massAgent.SetAppParameter("MassTools.AvailableBW2.AvailableBW2", "SetRemoteAddr", new object[] { strIP });
            }
            formConn.Dispose();
        }

        private void menuItem4_Click(object sender, EventArgs e)
        {

        }

        private void menuItem5_Click(object sender, EventArgs e)
        {
            massAgent.Start();
        }

        private void menuItem6_Click(object sender, EventArgs e)
        {
            massAgent.Stop();
        }

        private void menuItem8_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void FormMain_Closed(object sender, EventArgs e)
        {
            massAgent.Dispose();
            GC.Collect();
        }
    }
}